> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Execute virtual GPU cluster action

> Perform a specific action on a virtual GPU cluster.
Available actions: start, stop, soft reboot, hard reboot, resize



## OpenAPI

````yaml /api-reference/services_documented/cloud_api.yaml post /cloud/v3/gpu/virtual/{project_id}/{region_id}/clusters/{cluster_id}/action
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Cloud API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-11T15:10:30.328297+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: Bare Metal
    x-displayName: Bare Metal
  - name: Container as a Service
    x-displayName: Container as a Service
  - name: Cost Reports
    x-displayName: Cost Reports
  - name: DDoS Protection
    x-displayName: DDoS Protection
  - name: Everywhere Inference
    x-displayName: Everywhere Inference
  - name: Everywhere Inference Apps
    x-displayName: Everywhere Inference Apps
  - name: File Shares
    x-displayName: File Shares
  - name: Floating IPs
    x-displayName: Floating IPs
  - name: Function as a Service
    x-displayName: Function as a Service
  - name: GPU Bare Metal
    x-displayName: GPU Bare Metal
  - name: GPU Virtual
    x-displayName: GPU Virtual
  - name: IP Ranges
    x-displayName: IP Ranges
  - name: Images
    x-displayName: Images
  - name: Instances
    x-displayName: Instances
  - name: Load Balancers
    x-displayName: Load Balancers
  - name: Logging
    x-displayName: Logging
  - name: Managed Kubernetes
    x-displayName: Managed Kubernetes
  - name: Managed PostgreSQL
    x-displayName: Managed PostgreSQL
  - name: Networks
    x-displayName: Networks
  - name: Placement Groups
    x-displayName: Placement Groups
  - name: Projects
    x-displayName: Projects
  - name: Quotas
    x-displayName: Quotas
  - name: Regions
    x-displayName: Regions
  - name: Registry
    x-displayName: Registry
  - name: Reservations
    x-displayName: Reservations
  - name: Reserved IPs
    x-displayName: Reserved IPs
  - name: Routers
    x-displayName: Routers
  - name: SSH Keys
    x-displayName: SSH Keys
  - name: Secrets
    x-displayName: Secrets
  - name: Security Groups
    x-displayName: Security Groups
  - name: Snapshot Schedules
    x-displayName: Snapshot Schedules
  - name: Snapshots
    x-displayName: Snapshots
  - name: Tasks
    x-displayName: Tasks
  - name: User Actions
    x-displayName: User Actions
  - name: User Role Assignments
    x-displayName: User Role Assignments
  - name: Volumes
    x-displayName: Volumes
paths:
  /cloud/v3/gpu/virtual/{project_id}/{region_id}/clusters/{cluster_id}/action:
    post:
      tags:
        - GPU Virtual
      summary: Execute virtual GPU cluster action
      description: |-
        Perform a specific action on a virtual GPU cluster.
        Available actions: start, stop, soft reboot, hard reboot, resize
      operationId: VirtualClusterInstanceActions.post
      parameters:
        - in: path
          name: project_id
          required: true
          description: Project ID
          schema:
            description: Project ID
            example: 1
            examples:
              - 1
            title: Project Id
            type: integer
        - in: path
          name: region_id
          required: true
          description: Region ID
          schema:
            description: Region ID
            example: 7
            examples:
              - 7
            title: Region Id
            type: integer
        - in: path
          name: cluster_id
          required: true
          description: Cluster unique identifier
          schema:
            description: Cluster unique identifier
            example: 1aaaab48-10d0-46d9-80cc-85209284ceb4
            examples:
              - 1aaaab48-10d0-46d9-80cc-85209284ceb4
            format: uuid4
            title: Cluster Id
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/VirtualGPUClusterActionSerializer'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TaskIDsSerializer'
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            task_id_list = client.cloud.gpu_virtual.clusters.action(
                cluster_id="1aaaab48-10d0-46d9-80cc-85209284ceb4",
                project_id=1,
                region_id=7,
                action="start",
            )
            print(task_id_list.tasks)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/cloud\"\n\t\"github.com/G-Core/gcore-go/option\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\ttaskIDList, err := client.Cloud.GPUVirtual.Clusters.Action(\n\t\tcontext.TODO(),\n\t\t\"1aaaab48-10d0-46d9-80cc-85209284ceb4\",\n\t\tcloud.GPUVirtualClusterActionParams{\n\t\t\tProjectID: gcore.Int(1),\n\t\t\tRegionID:  gcore.Int(7),\n\t\t\tOfStart:   &cloud.GPUVirtualClusterActionParamsBodyStart{},\n\t\t},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", taskIDList.Tasks)\n}\n"
components:
  schemas:
    VirtualGPUClusterActionSerializer:
      discriminator:
        mapping:
          hard_reboot:
            $ref: '#/components/schemas/HardRebootGPUClusterSerializer'
          resize:
            $ref: '#/components/schemas/ResizeVirtualGPUClusterSerializer'
          soft_reboot:
            $ref: '#/components/schemas/SoftRebootGPUClusterSerializer'
          start:
            $ref: '#/components/schemas/StartGPUClusterSerializer'
          stop:
            $ref: '#/components/schemas/StopGPUClusterSerializer'
        propertyName: action
      oneOf:
        - $ref: '#/components/schemas/StartGPUClusterSerializer'
        - $ref: '#/components/schemas/StopGPUClusterSerializer'
        - $ref: '#/components/schemas/SoftRebootGPUClusterSerializer'
        - $ref: '#/components/schemas/HardRebootGPUClusterSerializer'
        - $ref: '#/components/schemas/ResizeVirtualGPUClusterSerializer'
      title: VirtualGPUClusterActionSerializer
    TaskIDsSerializer:
      properties:
        tasks:
          description: >-
            List of task IDs representing asynchronous operations. Use these IDs
            to monitor operation progress:

            - `GET /v1/tasks/{task_id}` - Check individual task status and
            details

            Poll task status until completion (`FINISHED`/`ERROR`) before
            proceeding with dependent operations.
          example:
            - d478ae29-dedc-4869-82f0-96104425f565
          examples:
            - - d478ae29-dedc-4869-82f0-96104425f565
          items:
            type: string
          title: Tasks
          type: array
      required:
        - tasks
      title: TaskIDsSerializer
      type: object
    HardRebootGPUClusterSerializer:
      properties:
        action:
          const: hard_reboot
          description: Action name
          example: hard_reboot
          examples:
            - hard_reboot
          title: Action
          type: string
      required:
        - action
      title: HardRebootGPUClusterSerializer
      type: object
    ResizeVirtualGPUClusterSerializer:
      properties:
        action:
          const: resize
          description: Action name
          example: resize
          examples:
            - resize
          title: Action
          type: string
        servers_count:
          description: Requested servers count
          example: 5
          examples:
            - 5
          exclusiveMinimum: 0
          title: Servers Count
          type: integer
      required:
        - action
        - servers_count
      title: ResizeVirtualGPUClusterSerializer
      type: object
    SoftRebootGPUClusterSerializer:
      properties:
        action:
          const: soft_reboot
          description: Action name
          example: soft_reboot
          examples:
            - soft_reboot
          title: Action
          type: string
      required:
        - action
      title: SoftRebootGPUClusterSerializer
      type: object
    StartGPUClusterSerializer:
      properties:
        action:
          const: start
          description: Action name
          example: start
          examples:
            - start
          title: Action
          type: string
      required:
        - action
      title: StartGPUClusterSerializer
      type: object
    StopGPUClusterSerializer:
      properties:
        action:
          const: stop
          description: Action name
          example: stop
          examples:
            - stop
          title: Action
          type: string
      required:
        - action
      title: StopGPUClusterSerializer
      type: object
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````